Index: logging.c
===================================================================
--- logging.c	(revision 91634ec817b2d3dfda0c429002c8450e4f2404d5)
+++ logging.c	(revision 839697d886ff0c8987d4f6233e92a81a5157faed)
@@ -128,4 +128,5 @@
   char filename[MAXPATHLEN], *logpath;
   char *to, *temp;
+  GList *cc;
 
   /* expand ~ in path names */
@@ -135,15 +136,14 @@
   if (owl_message_is_type_zephyr(m)) {
     /* If this has CC's, do all but the "recipient" which we'll do below */
-    to = owl_message_get_cc_without_recipient(m);
-    if (to != NULL) {
-      temp = strtok(to, " ");
-      while (temp != NULL) {
-          temp = short_zuser(temp);
-          snprintf(filename, MAXPATHLEN, "%s/%s", logpath, temp);
-          owl_log_append(m, filename);
-          temp = strtok(NULL, " ");
-      }
-      owl_free(to);
-    }
+    cc = owl_message_get_cc_without_recipient(m);
+    while (cc != NULL) {
+      temp = short_zuser(cc->data);
+      snprintf(filename, MAXPATHLEN, "%s/%s", logpath, temp);
+      owl_log_append(m, filename);
+
+      owl_free(cc->data);
+      cc = g_list_delete_link(cc, cc);
+    }
+
     to = short_zuser(owl_message_get_recipient(m));
   } else if (owl_message_is_type_jabber(m)) {
@@ -325,17 +325,16 @@
      * the sender, as well.
      */
-    char *cc, *temp;
+    char *temp;
+    GList *cc;
     cc = owl_message_get_cc_without_recipient(m);
-    if (cc != NULL) {
-      temp = strtok(cc, " ");
-      while (temp != NULL) {
-        temp = short_zuser(temp);
-        if (strcasecmp(temp, frombuff) != 0) {
-          snprintf(filename, MAXPATHLEN, "%s/%s", logpath, temp);
-          owl_log_append(m, filename);
-        }
-        temp = strtok(NULL, " ");
+    while (cc != NULL) {
+      temp = short_zuser(cc->data);
+      if (strcasecmp(temp, frombuff) != 0) {
+        snprintf(filename, MAXPATHLEN, "%s/%s", logpath, temp);
+        owl_log_append(m, filename);
       }
-      owl_free(cc);
+
+      owl_free(cc->data);
+      cc = g_list_delete_link(cc, cc);
     }
   }
Index: mainpanel.c
===================================================================
--- mainpanel.c	(revision 4eee9482aeaa92aa1199b5d6ca4141afdf5f0791)
+++ mainpanel.c	(revision 4eee9482aeaa92aa1199b5d6ca4141afdf5f0791)
@@ -0,0 +1,57 @@
+#include "owl.h"
+
+void owl_mainpanel_init(owl_mainpanel *mp)
+{
+  /* Create windows */
+  mp->panel = owl_window_new(NULL);
+  /* HACK for now: the sepwin must be drawn /after/ the recwin for
+   * lastdisplayed to work */
+  mp->sepwin = owl_window_new(mp->panel);
+  mp->recwin = owl_window_new(mp->panel);
+  mp->msgwin = owl_window_new(mp->panel);
+  mp->typwin = owl_window_new(mp->panel);
+
+  /* Set up sizing hooks */
+  owl_signal_connect_object(owl_window_get_screen(), "resized", G_CALLBACK(owl_window_fill_parent_cb), mp->panel, 0);
+  g_signal_connect_swapped(mp->panel, "resized", G_CALLBACK(owl_mainpanel_layout_contents), mp);
+
+  /* Bootstrap the sizes and go */
+  owl_window_fill_parent_cb(owl_window_get_screen(), mp->panel);
+  owl_window_show_all(mp->panel);
+}
+
+void owl_mainpanel_layout_contents(owl_mainpanel *mp)
+{
+  int lines, cols, typwin_lines;
+
+  /* skip if we haven't been initialized */
+  if (!mp->panel) return;
+
+  owl_window_get_position(mp->panel, &lines, &cols, NULL, NULL);
+  typwin_lines = owl_global_get_typwin_lines(&g);
+
+  /* set the new window sizes */
+  mp->recwinlines=lines-(typwin_lines+2);
+  if (mp->recwinlines<0) {
+    /* gotta deal with this */
+    mp->recwinlines=0;
+    typwin_lines = lines - 2;
+  }
+
+  /* resize all the windows */
+  owl_window_set_position(mp->recwin, mp->recwinlines, cols, 0, 0);
+  owl_window_set_position(mp->sepwin, 1, cols, mp->recwinlines, 0);
+  owl_window_set_position(mp->msgwin, 1, cols, mp->recwinlines+1, 0);
+  owl_window_set_position(mp->typwin, typwin_lines, cols, mp->recwinlines+2, 0);
+}
+
+void owl_mainpanel_cleanup(owl_mainpanel *mp)
+{
+  owl_window_unlink(mp->panel);
+  g_object_unref(mp->panel);
+  g_object_unref(mp->recwin);
+  g_object_unref(mp->sepwin);
+  g_object_unref(mp->msgwin);
+  g_object_unref(mp->typwin);
+  mp->panel = mp->recwin = mp->sepwin = mp->msgwin = mp->typwin = NULL;
+}
Index: mainwin.c
===================================================================
--- mainwin.c	(revision f449096479541df1434d1d796890d0bd2939f072)
+++ mainwin.c	(revision 5cc7e5e45702da552c2ba2d3eb236eaeca359eb4)
@@ -1,11 +1,42 @@
 #include "owl.h"
 
-void owl_mainwin_init(owl_mainwin *mw)
+static void owl_mainwin_redraw(owl_window *w, WINDOW *recwin, void *user_data);
+static void owl_mainwin_resized(owl_window *w, void *user_data);
+
+void owl_mainwin_init(owl_mainwin *mw, owl_window *window)
 {
   mw->curtruncated=0;
   mw->lastdisplayed=-1;
+  mw->window = g_object_ref(window);
+  /* for now, just assume this object lasts forever */
+  g_signal_connect(window, "redraw", G_CALLBACK(owl_mainwin_redraw), mw);
+  g_signal_connect(window, "resized", G_CALLBACK(owl_mainwin_resized), mw);
+  owl_window_dirty(window);
+
+  /* For now, we do not bother with connecting up dependencies; that'll be a
+   * future refactor of the mainwin */
+}
+
+static void owl_mainwin_resized(owl_window *w, void *user_data)
+{
+  owl_mainwin *mw = user_data;
+
+  /* in case any styles rely on the current width */
+  owl_messagelist_invalidate_formats(owl_global_get_msglist(&g));
+
+  /* recalculate the topmsg to make sure the current message is on
+   * screen */
+  owl_function_calculate_topmsg(OWL_DIRECTION_NONE);
+
+  /* Schedule a redraw */
+  owl_window_dirty(mw->window);
 }
 
 void owl_mainwin_redisplay(owl_mainwin *mw)
+{
+  owl_window_dirty(mw->window);
+}
+
+static void owl_mainwin_redraw(owl_window *w, WINDOW *recwin, void *user_data)
 {
   owl_message *m;
@@ -13,10 +44,9 @@
   int x, y, savey, recwinlines, start;
   int topmsg, curmsg, markedmsgid, fgcolor, bgcolor;
-  WINDOW *recwin;
   const owl_view *v;
   GList *fl;
   const owl_filter *f;
+  owl_mainwin *mw = user_data;
 
-  recwin = owl_global_get_curs_recwin(&g);
   topmsg = owl_global_get_topmsg(&g);
   curmsg = owl_global_get_curmsg(&g);
@@ -43,5 +73,4 @@
     mw->curtruncated=0;
     mw->lastdisplayed=-1;
-    owl_global_set_needrefresh(&g);
     return;
   }
@@ -88,5 +117,5 @@
     if (y+lines > recwinlines-1) {
       isfull=1;
-      owl_message_curs_waddstr(m, owl_global_get_curs_recwin(&g),
+      owl_message_curs_waddstr(m, recwin,
 			       start,
 			       start+recwinlines-y,
@@ -96,5 +125,5 @@
     } else {
       /* otherwise print the whole thing */
-      owl_message_curs_waddstr(m, owl_global_get_curs_recwin(&g),
+      owl_message_curs_waddstr(m, recwin,
 			       start,
 			       start+lines,
@@ -139,6 +168,4 @@
   }
   mw->lastdisplayed=i-1;
-
-  owl_global_set_needrefresh(&g);
 }
 
Index: message.c
===================================================================
--- message.c	(revision 9a7b4f23cba7fc71c4e918b5cb8d5ca6789924e3)
+++ message.c	(revision c314f397830b8cfa20a9540a606bad42845e7d9f)
@@ -61,9 +61,11 @@
   owl_pair *p = NULL, *pair = NULL;
 
+  attrname = g_intern_string(attrname);
+
   /* look for an existing pair with this key, */
   j=owl_list_get_size(&(m->attributes));
   for (i=0; i<j; i++) {
     p=owl_list_get_element(&(m->attributes), i);
-    if (!strcmp(owl_pair_get_key(p), attrname)) {
+    if (owl_pair_get_key(p) == attrname) {
       owl_free(owl_pair_get_value(p));
       pair = p;
@@ -74,5 +76,5 @@
   if(pair ==  NULL) {
     pair = owl_malloc(sizeof(owl_pair));
-    owl_pair_create(pair, owl_global_intern(&g, attrname), NULL);
+    owl_pair_create(pair, attrname, NULL);
     owl_list_append_element(&(m->attributes), pair);
   }
@@ -87,9 +89,16 @@
   int i, j;
   owl_pair *p;
+  GQuark quark;
+
+  quark = g_quark_try_string(attrname);
+  if (quark == 0)
+    /* don't bother inserting into string table */
+    return NULL;
+  attrname = g_quark_to_string(quark);
 
   j=owl_list_get_size(&(m->attributes));
   for (i=0; i<j; i++) {
     p=owl_list_get_element(&(m->attributes), i);
-    if (!strcmp(owl_pair_get_key(p), attrname)) {
+    if (owl_pair_get_key(p) == attrname) {
       return(owl_pair_get_value(p));
     }
@@ -496,5 +505,5 @@
 void owl_message_set_hostname(owl_message *m, const char *hostname)
 {
-  m->hostname=owl_global_intern(&g, hostname);
+  m->hostname = g_intern_string(hostname);
 }
 
@@ -584,8 +593,9 @@
 
 /* caller must free return value */
-char *owl_message_get_cc_without_recipient(const owl_message *m)
-{
-  char *cc, *out, *end, *shortuser, *recip;
+GList *owl_message_get_cc_without_recipient(const owl_message *m)
+{
+  char *cc, *shortuser, *recip;
   const char *user;
+  GList *out = NULL;
 
   cc = owl_message_get_cc(m);
@@ -594,6 +604,4 @@
 
   recip = short_zuser(owl_message_get_recipient(m));
-  out = owl_malloc(strlen(cc) + 2);
-  end = out;
 
   user = strtok(cc, " ");
@@ -601,20 +609,12 @@
     shortuser = short_zuser(user);
     if (strcasecmp(shortuser, recip) != 0) {
-      strcpy(end, user);
-      end[strlen(user)] = ' ';
-      end += strlen(user) + 1;
+      out = g_list_prepend(out, owl_strdup(user));
     }
     owl_free(shortuser);
     user = strtok(NULL, " ");
   }
-  end[0] = '\0';
 
   owl_free(recip);
   owl_free(cc);
-
-  if (strlen(out) == 0) {
-    owl_free(out);
-    out = NULL;
-  }
 
   return(out);
@@ -732,4 +732,39 @@
   owl_message_set_recipient(m, "looprecip");
   owl_message_set_isprivate(m);
+}
+
+void owl_message_save_ccs(owl_message *m) {
+  GList *cc;
+  char *tmp;
+
+  cc = owl_message_get_cc_without_recipient(m);
+
+  if (cc != NULL) {
+    GString *recips = g_string_new("");
+    cc = g_list_prepend(cc, short_zuser(owl_message_get_sender(m)));
+    cc = g_list_prepend(cc, short_zuser(owl_message_get_recipient(m)));
+    cc = g_list_sort(cc, (GCompareFunc)strcasecmp);
+
+    while(cc != NULL) {
+      /* Collapse any identical entries */
+      while (cc->next && strcasecmp(cc->data, cc->next->data) == 0) {
+        owl_free(cc->data);
+        cc = g_list_delete_link(cc, cc);
+      }
+
+      tmp = short_zuser(cc->data);
+      g_string_append(recips, tmp);
+
+      owl_free(tmp);
+      owl_free(cc->data);
+      cc = g_list_delete_link(cc, cc);
+
+      if (cc)
+        g_string_append_c(recips, ' ');
+    }
+
+    owl_message_set_attribute(m, "zephyr_ccs", recips->str);
+    g_string_free(recips, true);
+  }
 }
 
@@ -869,4 +904,6 @@
     }
   }
+
+  owl_message_save_ccs(m);
 }
 #else
@@ -963,4 +1000,6 @@
     owl_message_set_isprivate(m);
   }
+
+  owl_message_save_ccs(m);
 }
 
Index: msgwin.c
===================================================================
--- msgwin.c	(revision 23b6c118279eabdaa1e3d8d2d600a97bce616017)
+++ msgwin.c	(revision 23b6c118279eabdaa1e3d8d2d600a97bce616017)
@@ -0,0 +1,46 @@
+#include "owl.h"
+
+static void owl_msgwin_redraw(owl_window *w, WINDOW *curswin, void *msgwin_);
+
+/* Maintains a small status window of text */
+
+void owl_msgwin_init(owl_msgwin *msgwin, owl_window *window)
+{
+  msgwin->msg = NULL;
+  msgwin->window = g_object_ref(window);
+  msgwin->redraw_id = g_signal_connect(window, "redraw", G_CALLBACK(owl_msgwin_redraw), msgwin);
+  owl_window_dirty(window);
+}
+
+static void owl_msgwin_redraw(owl_window *w, WINDOW *curswin, void *msgwin_)
+{
+  owl_msgwin *msgwin = msgwin_;
+
+  werase(curswin);
+  if (msgwin->msg)
+    waddstr(curswin, msgwin->msg);  
+}
+
+void owl_msgwin_set_text(owl_msgwin *msgwin, const char *msg)
+{
+  owl_msgwin_set_text_nocopy(msgwin, owl_strdup(msg));
+}
+
+void owl_msgwin_set_text_nocopy(owl_msgwin *msgwin, char *msg)
+{
+  owl_free(msgwin->msg);
+  msgwin->msg = msg;
+  owl_window_dirty(msgwin->window);
+}
+
+void owl_msgwin_cleanup(owl_msgwin *msgwin)
+{
+  owl_free(msgwin->msg);
+  msgwin->msg = NULL;
+  if (msgwin->window) {
+    g_signal_handler_disconnect(msgwin->window, msgwin->redraw_id);
+    g_object_unref(msgwin->window);
+    msgwin->window = NULL;
+    msgwin->redraw_id = 0;
+  }
+}
Index: owl.c
===================================================================
--- owl.c	(revision d12a8c71f5d91653b1bffd9fa566448eb52b5d43)
+++ owl.c	(revision 205e1645be4619c39f0963639fd7bfb7b0ec5195)
@@ -137,6 +137,6 @@
   tcgetattr(0, &tio);
   tio.c_iflag &= ~(ISTRIP|IEXTEN);
-  tio.c_cc[VQUIT] = 0;
-  tio.c_cc[VSUSP] = 0;
+  tio.c_cc[VQUIT] = fpathconf(STDIN, _PC_VDISABLE);
+  tio.c_cc[VSUSP] = fpathconf(STDIN, _PC_VDISABLE);
   tcsetattr(0, TCSAFLUSH, &tio);
 
@@ -240,4 +240,6 @@
   /* log the message if we need to */
   owl_log_message(m);
+  /* redraw the sepbar; TODO: don't violate layering */
+  owl_global_sepbar_dirty(&g);
 
   return 1;
@@ -272,6 +274,4 @@
     /* this should be optimized to not run if the new messages won't be displayed */
     owl_mainwin_redisplay(owl_global_get_mainwin(&g));
-    sepbar(NULL);
-    owl_global_set_needrefresh(&g);
   }
   return newmsgs;
@@ -428,26 +428,7 @@
 {
   /* if a resize has been scheduled, deal with it */
-  owl_global_resize(&g, 0, 0);
-  /* also handle relayouts */
-  owl_global_relayout(&g);
-
+  owl_global_check_resize(&g);
   /* update the terminal if we need to */
-  if (owl_global_is_needrefresh(&g)) {
-    /* these are here in case a relayout changes the windows */
-    WINDOW *sepwin = owl_global_get_curs_sepwin(&g);
-    WINDOW *typwin = owl_global_get_curs_typwin(&g);
-
-    /* push all changed windows to screen */
-    update_panels();
-    /* leave the cursor in the appropriate window */
-    if (!owl_popwin_is_active(owl_global_get_popwin(&g))
-	&& owl_global_get_typwin(&g)) {
-      owl_function_set_cursor(typwin);
-    } else {
-      owl_function_set_cursor(sepwin);
-    }
-    doupdate();
-    owl_global_set_noneedrefresh(&g);
-  }
+  owl_window_redraw_scheduled();
   return 0;
 }
@@ -517,5 +498,5 @@
 
   owl_global_pop_context(&g);
-  owl_global_push_context(&g, OWL_CTX_READCONFIG, NULL, NULL);
+  owl_global_push_context(&g, OWL_CTX_READCONFIG, NULL, NULL, NULL);
 
   perlerr=owl_perlconfig_initperl(opts.configfile, &argc, &argv, &env);
@@ -561,5 +542,4 @@
     "-----------------------------------------------------------------m-m---\n"
   );
-  sepbar(NULL);
 
   /* process the startup file */
@@ -585,8 +565,5 @@
 
   owl_global_pop_context(&g);
-  owl_global_push_context(&g, OWL_CTX_READCONFIG|OWL_CTX_RECV, NULL, "recv");
-
-  /* If we ever deprecate the mainloop hook, remove this. */
-  owl_select_add_timer(0, 1, owl_perlconfig_mainloop, NULL, NULL);
+  owl_global_push_context(&g, OWL_CTX_READCONFIG|OWL_CTX_RECV, NULL, "recv", NULL);
 
   owl_select_add_pre_select_action(owl_refresh_pre_select_action, NULL, NULL);
Index: owl.h
===================================================================
--- owl.h	(revision 26ad412433e18b39230531a2a518a03bffc1d3d4)
+++ owl.h	(revision 26ad412433e18b39230531a2a518a03bffc1d3d4)
@@ -60,4 +60,6 @@
 typedef void HV;
 #endif
+
+#include "window.h"
 
 #ifdef  GIT_VERSION
@@ -308,4 +310,5 @@
   void *data;		/* determined by mode */
   char *keymap;
+  owl_window *cursor;
 } owl_context;
 
@@ -344,4 +347,5 @@
 
 typedef struct _owl_zwrite {
+  char *cmd;
   char *zwriteline;
   char *class;
@@ -394,4 +398,5 @@
   int lasttruncated;
   int lastdisplayed;
+  owl_window *window;
 } owl_mainwin;
 
@@ -401,6 +406,6 @@
   int topline;
   int rightshift;
-  int winlines, wincols;
-  WINDOW *curswin;
+  owl_window *window;
+  gulong sig_redraw_id;
   void (*onclose_hook) (struct _owl_viewwin *vwin, void *data);
   void *onclose_hook_data;
@@ -408,10 +413,14 @@
   
 typedef struct _owl_popwin {
-  PANEL *borderpanel;
-  PANEL *poppanel;
-  int lines;
-  int cols;
+  owl_window *border;
+  owl_window *content;
   int active;
 } owl_popwin;
+  
+typedef struct _owl_msgwin {
+  char *msg;
+  owl_window *window;
+  gulong redraw_id;
+} owl_msgwin;
 
 typedef struct _owl_messagelist {
@@ -463,4 +472,13 @@
 typedef struct _owl_editwin_excursion owl_editwin_excursion;
 
+typedef struct _owl_mainpanel {
+  owl_window *panel;
+  owl_window *typwin;
+  owl_window *sepwin;
+  owl_window *msgwin;
+  owl_window *recwin;
+  int recwinlines;
+} owl_mainpanel;
+
 typedef struct _owl_keybinding {
   int  *keys;			/* keypress stack */
@@ -476,5 +494,5 @@
   char     *desc;		/* description */
   owl_list  bindings;		/* key bindings */
-  const struct _owl_keymap *submap;	/* submap */
+  const struct _owl_keymap *parent;	/* parent */
   void (*default_fn)(owl_input j);	/* default action (takes a keypress) */
   void (*prealways_fn)(owl_input  j);	/* always called before a keypress is received */
@@ -521,8 +539,4 @@
   short **pairs;
 } owl_colorpair_mgr;
-
-typedef struct _owl_obarray {
-  owl_list strings;
-} owl_obarray;
 
 typedef struct _owl_io_dispatch {
@@ -550,7 +564,10 @@
 } owl_popexec;
 
+typedef struct _OwlGlobalNotifier OwlGlobalNotifier;
+
 typedef struct _owl_global {
   owl_mainwin mw;
   owl_popwin pw;
+  owl_msgwin msgwin;
   owl_history cmdhist;		/* command history */
   owl_history msghist;		/* outgoing message history */
@@ -570,10 +587,8 @@
   owl_messagelist msglist;
   WINDOW *input_pad;
-  PANEL *recpan, *seppan, *msgpan, *typpan;
-  int needrefresh;
+  owl_mainpanel mainpanel;
+  gulong typwin_erase_id;
   int rightshift;
   volatile sig_atomic_t resizepending;
-  int relayoutpending;
-  int recwinlines;
   char *thishost;
   char *homedir;
@@ -599,5 +614,4 @@
   owl_colorpair_mgr cpmgr;
   pid_t newmsgproc_pid;
-  int malloced, freed;
   owl_regex search_re;
   aim_session_t aimsess;
@@ -610,5 +624,5 @@
   char *aim_screenname_for_filters;     /* currently logged in AIM screen name */
   owl_buddylist buddylist;  /* list of logged in AIM buddies */
-  owl_list messagequeue;    /* for queueing up aim and other messages */
+  GQueue *messagequeue;     /* for queueing up aim and other messages */
   owl_dict styledict;       /* global dictionary of available styles */
   char *response;           /* response to the last question asked */
@@ -623,5 +637,4 @@
   int pseudologin_notify;
   struct termios startup_tio;
-  owl_obarray obarray;
   owl_list io_dispatch_list;
   owl_list psa_list;
Index: perl/lib/BarnOwl/Hooks.pm
===================================================================
--- perl/lib/BarnOwl/Hooks.pm	(revision b30c2569225bbfe24cb09819d5ac4dfa509b7f1c)
+++ perl/lib/BarnOwl/Hooks.pm	(revision 3aa05226f2c729940957d231891ed429669e255f)
@@ -79,9 +79,11 @@
 our %EXPORT_TAGS = (all => [@EXPORT_OK]);
 
+use BarnOwl::MainLoopCompatHook;
+
 our $startup = BarnOwl::Hook->new;
 our $shutdown = BarnOwl::Hook->new;
 our $receiveMessage = BarnOwl::Hook->new;
 our $newMessage = BarnOwl::Hook->new;
-our $mainLoop = BarnOwl::Hook->new;
+our $mainLoop = BarnOwl::MainLoopCompatHook->new;
 our $getBuddyList = BarnOwl::Hook->new;
 our $getQuickstart = BarnOwl::Hook->new;
@@ -162,4 +164,5 @@
     }
     
+    $mainLoop->check_owlconf();
     $startup->run(0);
     BarnOwl::startup() if *BarnOwl::startup{CODE};
@@ -186,9 +189,4 @@
     
     BarnOwl::new_msg($m) if *BarnOwl::new_msg{CODE};
-}
-
-sub _mainloop_hook {
-    $mainLoop->run;
-    BarnOwl::mainloop_hook() if *BarnOwl::mainloop_hook{CODE};
 }
 
Index: perl/lib/BarnOwl/MainLoopCompatHook.pm
===================================================================
--- perl/lib/BarnOwl/MainLoopCompatHook.pm	(revision 3aa05226f2c729940957d231891ed429669e255f)
+++ perl/lib/BarnOwl/MainLoopCompatHook.pm	(revision 3aa05226f2c729940957d231891ed429669e255f)
@@ -0,0 +1,64 @@
+use strict;
+use warnings;
+
+package BarnOwl::MainLoopCompatHook;
+
+use BarnOwl;
+use BarnOwl::Hook;
+use BarnOwl::Timer;
+use Scalar::Util qw(weaken);
+
+sub new {
+    my $class = shift;
+    my $hook = BarnOwl::Hook->new;
+    return bless {hook => $hook}, $class;
+}
+
+sub check_owlconf {
+  my $self = shift;
+  $self->_ensure_timer() if (*BarnOwl::mainloop_hook{CODE});
+}
+
+sub run {
+    my $self = shift;
+    return $self->{hook}->run(@_);
+}
+
+sub add {
+    my $self = shift;
+    $self->_ensure_timer();
+    $self->{hook}->add(@_);
+}
+
+sub clear {
+    my $self = shift;
+    $self->_kill_timer() unless *BarnOwl::mainloop_hook{CODE};
+    $self->{hook}->clear();
+}
+
+sub _ensure_timer {
+  my $self = shift;
+  BarnOwl::debug("Enabling backwards-compatibility \"main loop\" hook");
+  my $weak = $self;
+  weaken($weak);
+  unless ($self->{timer}) {
+    $self->{timer} = BarnOwl::Timer->new( {
+        after => 0,
+        interval => 1,
+        cb => sub {
+          $weak->run if $weak;
+          BarnOwl::mainloop_hook() if *BarnOwl::mainloop_hook{CODE};
+        },
+      } );
+  }
+}
+
+sub _kill_timer {
+  my $self = shift;
+  if ($self->{timer}) {
+    $self->{timer}->stop;
+    undef $self->{timer};
+  }
+}
+
+1;
Index: perl/lib/BarnOwl/Message/Generic.pm
===================================================================
--- perl/lib/BarnOwl/Message/Generic.pm	(revision ee183beb7b1f02ed315026b95d9d72e0913908bd)
+++ perl/lib/BarnOwl/Message/Generic.pm	(revision 5d1324f0b0edf2200def6c9e613517404a515c42)
@@ -6,4 +6,6 @@
 use base qw( BarnOwl::Message );
 
+sub body { "" }
+
 
 1;
Index: perl/lib/BarnOwl/Style/Default.pm
===================================================================
--- perl/lib/BarnOwl/Style/Default.pm	(revision 0fe69d275af9f0d0a83259b7494566c102b17902)
+++ perl/lib/BarnOwl/Style/Default.pm	(revision 08544e017df1dc0ff7d3735a4c93705de1007707)
@@ -32,4 +32,9 @@
     my $m = shift;
     return $m->is_personal && $m->direction eq "in";
+}
+
+sub maybe {
+    my $x = shift;
+    return defined($x) ? $x : "";
 }
 
@@ -99,5 +104,5 @@
             $header .= ' / ' . $self->humanize($m->subcontext, 1);
         }
-        $header .= ' / @b{' . $m->pretty_sender . '}';
+        $header .= ' / @b{' . maybe($m->pretty_sender) . '}';
     }
 
Index: perl/lib/BarnOwl/Timer.pm
===================================================================
--- perl/lib/BarnOwl/Timer.pm	(revision ee183beb7b1f02ed315026b95d9d72e0913908bd)
+++ perl/lib/BarnOwl/Timer.pm	(revision 8d16e58dfb7d32aaae1378039fbbde334d5ab660)
@@ -21,4 +21,12 @@
 }
 
+sub stop {
+    my $self = shift;
+    if(defined($self->{timer})) {
+        BarnOwl::Internal::remove_timer($self->{timer});
+        undef $self->{timer};
+    }
+}
+
 sub do_callback {
     my $self = shift;
@@ -28,7 +36,5 @@
 sub DESTROY {
     my $self = shift;
-    if(defined($self->{timer})) {
-        BarnOwl::Internal::remove_timer($self->{timer});
-    }
+    $self->stop;
 }
 
Index: perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm	(revision c854e74bbef86a0225ca76c3945b9f9485b829db)
+++ perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm	(revision 2f25537acb67e620a5be5052f5c2f9a1e5fe3abd)
@@ -20,4 +20,5 @@
 sub to { shift->{to} };
 sub room { shift->{room} };
+sub nick { shift->{nick} };
 sub subject { shift->{subject} };
 sub status { shift->{status} }
@@ -41,4 +42,11 @@
 sub long_sender {
     my $self = shift;
+    if ($self->jtype eq 'groupchat' && $self->nick) {
+        my $from_jid = Net::Jabber::JID->new($self->from);
+        if ($from_jid->GetJID('base') eq $self->room &&
+            $from_jid->GetResource() eq $self->nick) {
+            return $self->nick;
+        }
+    }
     return $self->from;
 }
@@ -77,7 +85,15 @@
     } elsif ($self->jtype eq 'groupchat') {
         my $room = $self->room;
-        $filter = "jabber-room-$room";
-        BarnOwl::command(qw[filter], $filter,
-                         qw[type ^jabber$ and room], "^\Q$room\E\$");
+        if ($inst) {
+            my $subject = $self->subject;
+            $filter = "jabber-room-$room-subject-$subject";
+            BarnOwl::command(qw[filter], $filter,
+                             qw[type ^jabber$ and room], "^\Q$room\E\$",
+                             qw[and subject], "^\Q$subject\E\$");
+        } else {
+            $filter = "jabber-room-$room";
+            BarnOwl::command(qw[filter], $filter,
+                             qw[type ^jabber$ and room], "^\Q$room\E\$");
+        }
         return $filter;
     } elsif ($self->login ne 'none') {
